package SOFA.GeneratedConnectors.H0000000000000014;

public class DataStreamLocalSender implements SOFA.Connector.EEG.Types.Sender, SOFA.GeneratedConnectors.H000000000000000e.CNInterface {

	protected SOFA.Connector.EEG.ConnectorManagerInterface manager;

	public void setManagerTie(SOFA.Connector.EEG.ConnectorManagerInterface manager) {
		this.manager=manager;
	}

	public SOFA.Connector.EEG.ConnectorManagerInterface getManagerTie() {
		return manager;
	}

	protected java.lang.reflect.Method receiverWrite;
	protected Object receiverWriteParams[]=new Object[3];
	protected Object receiver;
	protected SOFA.GeneratedConnectors.H0000000000000010.CNInterface client;

	public void link(Object target) throws SOFA.Connector.LinkException {
		if (target instanceof SOFA.Connector.TaggedProfile) {
			receiver=((SOFA.Connector.ECG.Profiles.LocalProfile)target).link;
			try {
				receiverWrite=receiver.getClass().getMethod("write",new Class[] {byte[].class, Integer.TYPE, String.class});
			} catch (NoSuchMethodException e) {
				throw new SOFA.Connector.LinkException("Cannot create dynamic local binding",e);
			}
		} else {
			client=(SOFA.GeneratedConnectors.H0000000000000010.CNInterface)target;
		}
	}

	public String[] getSupportedProfiles() {
		return new String[] {"LOCAL"};
	}

	public void write(byte[] buffer, int len, String thr_id) {
		receiverWriteParams[0]=buffer;
		receiverWriteParams[1]=new Integer(len);
		receiverWriteParams[2]=thr_id;
		try {
			receiverWrite.invoke(receiver,receiverWriteParams);
		} catch (IllegalAccessException _e) {
			throw new SOFA.Connector.ConnectorTransportException("IllegalAccessException", _e);
		} catch (java.lang.reflect.InvocationTargetException _e) {
			throw new SOFA.Connector.ConnectorTransportException("InvocationTargetException", _e);
		}
	}



	public org.objectweb.fractal.api.Type getFcItfType() { return null; }
	public boolean isFcInternalItf() { return false; }
	public String getFcItfName() { throw new SOFA.Connector.ConnectorTransportException("Interconection via EventPassing connector - getFcItfName is not supported."); }
	public org.objectweb.fractal.api.Component getFcItfOwner() { throw new SOFA.Connector.ConnectorTransportException("Interconection via EventPassing connector - getFcItfOwner is not supported."); }


}
